c-- sirpow.92                                        Release 93.05
      program sirpow
      character file*80,line*80
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
c     input/output units, title, flags
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c-- trigonometric tables and constants
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/xdisu/ncdfu ,ndfle,irecx
c     scratch file reflexion arrays
      common /buffer/ vet(13,39),nrpb,dummb(7)
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common /setequ/ jpatt,jpunt(501),ksacc,jseteq,jumpp
c  
      ier=0
      call pc386(ier)
      if(ier.lt.0) go to 1000
c
      ncdfu=jdir
c     set flag for direct execution
      iexec=-1
c
c-- set up the default names for work files
c
      do 10 i=1,9
      file=fname(i)(1:30)//ext(i)
      call xcmprp(file,lfile)
      fname(i)=file
   10 continue
c
c-- define the number of reflections per block in scratch file
c--   nrpb = (number of words in block) / 13
c
      nrpb=knwr/13
      nrpb=min0(nrpb,42)
   50 call spoolr(line,newf,iexec,jfour,ier)
      if (ier.lt.0) go to 1000
c
c-- initialize graphics
c
      call scr1
c
      call sircom(newf,iexec,jfour,ier)
      if (ier.lt.0) go to 1000
      if (iexec.ge.0) go to 50
 1000 if (ier.lt.0) then
                      write(line,2000)
                    else
                      write(line,3000)
                    endif
      lline=24
      call scrend(line,lline)
      close (jdir)
      write(lo,4000) line(1:lline)
 2000 format(' SIRPOW.92 ends in error')
 3000 format(' SIRPOW.92 ends ok      ')
 4000 format(//,1h ,a)
      end
c-----------------------------------------------------------------------
      subroutine spoolr(line,newf,iexec,jfour,ier)
      character line*80,releas*5,com4*4
      character beg,commen,allcom(25)*14,dire*80,defa*7
      character itldef*8
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
c   direct access file commons
      common /xfile/ ifile,jjlist,jjend,infle,nwfle,icfle,lid(4)
      common /xfili/ lfirst,nwblo,lindex(240)
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /setequ/ jpatt,jpunt(501),ksacc,jseteq,jumpp
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common /chara/ blank,digit,card,ffile
      common /charas/ beg,commen,allcom
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      dimension vet(40),ivet(40)
      data itldef /' sirpow '/
c
      if (iexec.lt.0) then
                        pi=4.0*atan(1.0)
                        twopi=2.0*pi
                        rtod=180.0/pi
                        dtor=1.0/rtod
c     set up sin/cos table
                        do 50 i=1,450
                        sint(i)=sin(dtor*float(i-1))
   50                   continue
                        allcom(15)(1:1)=beg
                        do 100 i=1,19,2
                        read(itldef(1:4),'(a4)') itle(i  )
  100                   read(itldef(5:8),'(a4)') itle(i+1)
                        jfour=0
                      endif
      irefl=0
      kcont=0
      ier=0
      init=0
      nallc=25
      ipcom=0
      icomo=2
      ipdir=0
      nerr=0
      do 120 i=1,maxcom
      do 120 j=1,2
  120 icomq(i,j)=0
c
c-- read cards
c
  130 format(a)
      if (iexec.gt.0) write(lo,135) beg,beg,beg
  135 format(//,' Please enter commands and directives ( ',a1,a1,' to go
     *, ',a1,'end to stop )')
  140 read(ln,130,end=2000) line
      call shift(line,nchar)
      if (nchar.le.0.or.line(1:1).eq.commen) go to 140
c
c-- if first character is equal to '%' it is a command
c
      if (line(1:1).eq.beg) then
c
c-- check if the command is an "exec" one
c
            if (line(2:2).eq.beg) then
                                    iexec=iexec+1
c                                   return
                                    go to 165
                                  endif
CCCCCCCCCif (line(2:2).ne.blank) then
c
c-- verify if the command is allowed
c
         icom=0
         com4=line(2:5)
         call lcase(com4)
         do 150 i=1,nallc
         if (com4.eq.allcom(i)(1:4)) icom=i
  150    continue
         jcom=0
c
c-- if %PATTERSON next command must be %END
c
         if (icomo.eq.13) icom=7
c
         if (icom.eq.0) then
                           go to 3000
                         else
                           if (icom.eq.25) then
c
c--       the command is  %window
c
                                    call cutst(line,lenp,dire,lend)
                                    iopt=0
                                    call getnum(line,vet,ivet,iv,iopt)
                                    if (iv.eq.2) then
                                        kscrx=max0(639,ivet(1))
                                        kscry=max0(479,ivet(2))
                                    endif
                                            jcom=1
                                            kscreen=1
                                          endif
                           if (icom.eq.24) then
c
c--       the command is  %nowindow
c
                                            jcom=1
                                            kscreen=0
                                          endif
                           if (icom.eq.8) then
c
c--       the command is  %continue
c
                                            jcom=1
                                            icomo=icomo+1
                                            if (icomo.eq.2)  icomo=3
                                            if (icomo.eq.17) icomo=5
                                            if (icomo.eq.24) icomo=1
                                            do 160 ii=icomo,7
                                            if (ii.eq.2) go to 160
                                            ipcom=ipcom+1
                                            if (ipcom.gt.maxcom) 
     *                                      go to 6000
                                            icomq(ipcom,1)=ii
  160                                       continue            
                                          endif
                           if (icom.eq.11) then
c
c--       the command is  %permute 
c
                                          ifper=1
                                          endif
                           if (icom.eq.8) then
c
c--       the command is  %modify 
c
c                                         ippp=2
                                          endif
                           if (icom.eq.9) then
c
c--       the command is  %job
c
                                         jcom=1
                                         call cutst(line,lenp,dire,lend)
                                         read(line,'(20a4)') itle
                                       endif
C                          if (icom.eq.10) then
C
C--       the command is  %file
C
C                                        jcom=1
C     call cutst(line,lenp,dire,lend)
C     if (lenp.le.0) go to 1000
C     call cutst(line,lenp,dire,lend)
C     fname(1)=dire
C     if (lenp.gt.0) then
C                      call cutst(line,lenp,dire,lend)
C                      fname(3)=dire
C                    endif
C                                      endif
                           if (icom.eq.22) then
c
c--       the command is  %structure
c
                                         jcom=1
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 1000
      call cutst(line,lenp,dire,lend)
      do 163 i=1,6
 163  fname(i)=dire(1:lend)//ext(i)
      michae=min0(lend,6)
      do 164 i=7,9
 164  fname(i)=dire(1:michae)//ext(i)
                                       endif
                           if (icom.eq.12) then
c
c--       the command is %initialize
c
                                            jcom=1
                                            init=1
                                           endif
                           if (jcom.eq.0) then
                                            ipcom=ipcom+1
                                            if (ipcom.gt.200) go to 6000
                                            icomq(ipcom,1)=icom
                                            icomo=icom
                                          endif
                         endif
CCCCCCCCC                endif
          else
c
c-- it is a directive
c
            com4=line(1:4)
            call lcase(com4)
            if (ipcom.eq.0) go to 4000
            ipdir=ipdir+1
            if (ipdir.gt.100) go to 5000
            card(ipdir)=line
            icomq(ipcom,2)=icomq(ipcom,2)+1
            if (com4.eq.'scha'.or.
     *          com4.eq.'mold') then
                                  call cutst(line,lenp,dire,lend)
                                  fname(4)=line
                                endif
            if (com4.eq.'ref1'.or.com4.eq.'ref2') then
                        call cutst(line,lenp,dire,lend)
                        irefl=1
                        com4=line(1:4)
                        call lcase(com4)
                        if (com4.eq.'foll') then
                            jfile=ln
                            fname(2)=' '
                            fname(2)(1:20) ='card reader         '
                          else 
                            fname(2)=line
                          endif
                        endif
            if (com4.eq.'cont') kcont=1
          endif
      if (icom.ne.7.and.icom.ne.8) go to 140
      if (nerr.ne.0) go to 9000
  165 if (iexec.gt.0) return
      iexec=iexec+1
	  jcaos=0
      if (jcaos.eq.0) then
c-- initialize history array
      if (kenvir.eq.0) then
                         do 170 i=1,99
  170                    kstory(i)=0
                       endif
c-- set up internal structures
      call star9
      itipe=0
      if (kopen(jdir,fname(1),nlen,itipe,ierr).ge.0) go to 200
      write(lo,190) ierr,fname(1)
  190 format(' error ',i5,'  opening file ',a)
      ier=-1
      kscreen = 0
      return
  200 continue
      call xdwn(lfirst,lindex,10)
      newf=0
      if (init.eq.1) lindex(8)=ifile+1
      if (lindex(8).ne.ifile) then
                                call setfi
                                newf=1
                              endif
      call xlc
      call xcsae
             endif
c--
      write(lo,210) itle
  210 format(1h ,120('*'),/,20x,20a4,//)
      call wrhead
      write(lo,220)
  220 format(' Used  commands & directives:',/)
      jj=0
      do 240 i=1,ipcom
         do 225 j=1,80
  225    line(j:j)=blank
         j=icomq(i,1)
         if (j.eq.6) jfour=1
         write(line(1:26),'(11x,a1,a14)') beg,allcom(j)
         if (icomq(i,2).eq.0) then
                                defa='default'
                                if (icomq(i,1).eq.7) defa='       '
                                write(line(28:34),'(a7)') defa
                                write(lo,'(/,a)') line
                              else
                                do 230 j=1,icomq(i,2)
                                   jj=jj+1
                                   if (j.eq.1) then
                                 write(lo,'(/,a)') line(1:27)//card(jj)
                                               else
                                   write(lo,'(27x,a)') card(jj)
                                               endif
  230                           continue
                              endif
  240 continue
      write(lo,290) ln,lo,jdir,fname(1),iscra,jrel
      if (irefl.ne.0) write(lo,300) jfile,fname(2)
      if (kcont.eq.1)  then
                         itype=2
                         iform=1
                         jop=jopen(kform,ffile,nlen,itype,iform,ierr)
                         if (jop.lt.0) then
                                         write(lo,270) ierr,ffile
                                         ier=-1
                                         kscreen=0
                                       else
                         read(kform,280,iostat=ierr,err=7000) releas
                         write(lo,310) kform,ffile,releas
                         close (kform)
                         if (releas.ne.'93.05') then 
                                                  ier=-1
                                                  kscreen=0
                                                  write(lo,311) 
                                                endif
                                       endif
                       endif
      if (jfour.eq.1)  write(lo,320) jhost,fname(3),jgrap,fname(4),ifour
  270 format(' *** error ***  open error, code =',i5,' file is ',a)
  280 format(a5)
  290 format(//,' Files used in sirpow:',//,
     *     '  Channel                                  name',/,
     1            i6,'    card reader',/,
     2            i6,'    line printer',/,
     3            i6,'    direct access structure file     ',a,/,
     4            i6,'    direct access scratch file',/,
     5            i6,'    sequential scratch file ')
  300 format(     i6,'    reflection input file            ',a)
  310 format(     i6,'    scattering factors file          ',a,
     1     /, 6x,    '    ( Release : ',a5,' )')
  311 format(/, 6x,'    *** error ***  update this file !!',/)
  320 format(     i6,'    fourier peaks file               ',a,/,
     *            i6,'    peaks file to be plotted         ',a,/,
     *            i6,'    sequential scratch file ',//)
      write(lo,'(//)')
      if (newf.eq.1) then
          write(lo,330)
        else
          write(lo,340)
          call summar
        endif
  330 format(6x,'Direct access structure file has been initialized'//)
  340 format(6x,'Direct access structure file actually contains:'/)
      return
c--
 1000 continue
      write(lo,1010) 
 1010 format(' No structure name supplied')
      go to 9000
 2000 continue
      write(lo,2010)
 2010 format(' no   %end or %continue   command specified')
      go to 9000
 3000 continue
      write(lo,3010) line(1:nchar)
 3010 format(' error in command ',a)
      go to 9000
 4000 write(lo,4100) line(1:nchar)
 4100 format(' no command specified for directive ',a)
      go to 9000
 5000 write(lo,5100)
 5100 format(' more than 100 directives used ',/,
     *       ' check for missing  %end or %continue')
      go to 9000
 6000 write(lo,6100) maxcom
 6100 format(' more than ',i5,' commands used ',/,
     *       ' check input file or submit two jobs ')
      go to 9000
 7000 nrec=1
      write(lo,7100) ierr,nrec,ffile
 7100 format(' error ',i5,' reading record no. ',i3,' in file ',a)
 9000 ier=-1
      kscreen = 0
      return
      end
c-----------------------------------------------------------------------
      subroutine sircom(newf,iexec,jfour,ier)
c-- main subroutine to handle sir commands
      character beg,commen,allcom(25)*14
      common /charas/ beg,commen,allcom
      character fname(9)*80,ext(9)*4,host*80
      common/dotdat/ fname,ext
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /xlimi/ idummy(6),nfls
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /ureq1/ ncycl,nroset,nundset,alambda,nsec,machkl,uvwt(4),
     *               pfwhm
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /setequ/ jpatt,jpunt(501),ksacc,jseteq,jumpp
c
      ier=0
      ifper=0
      ipripe=1
      ncycl=0
      nroset=3
      if (jfour.eq.1)  then
                         itype=0
                         iform=1
                         jop=jopen(jhost,fname(3),nlen,itype,iform,ier)
                         if (jop.lt.0) go to 7000
                       endif
      ipdir =0
      icomat=0
   80 if (ier.lt.0) return
      nfls=1
      nfl=1
      npc=0
      icomat=icomat+1
      j=icomq(icomat,1)
      if (j.ne.0) then
      jj=kstory(20)+1
      kstory(20)=jj
      jj=jj+20
      if (jj.le.99) kstory(jj)=j
      if (j.eq. 4) call scrpd
      if (j.eq. 5) call scrfd
      if (j.eq.18) call scrrd
      call scr2
c
      go to (100,200,300,400,500,600,700,800,900,1000,
     *       1100,1200,1300,1400,1500,1600,1700,1800,
     *       1900,2000,2100,2200,2300,2400,2500),j
c-- normal     routine
  100 continue
      call normal(ier)
      go to 80
c-- seminvariants routine
  200 continue
      call seminv(ier)
      go to 80
c-- invariants routine
  300 continue
      call invar(ier)
      go to 80
c-- phase   routine
  400 continue
      call contan(ier)
      go to 80
c-- fourier routine
  500 continue
c     if (ifper.eq.1)  call setperm(ier)
      if (ier.lt.0) goto 80
      host=fname(3)
      call fourie(host,ier)
      go to 80
c-- export command
  600 continue
      call export(host,ier)
      go to 80
c-- end command
  700 continue
      go to 1500
c-- continue routine
  800 continue
      ier=-1
      go to 3000
c-- job command
  900 continue
      ier=-1
      go to 3000
c-- file command
 1000 continue
      ier=-1
      go to 3000
c-- permute command
 1100 continue
      call permut(ier)
      go to 80
c-- initialize
 1200 continue
      ier=-1
      go to 3000
c-- dummy command
 1300 continue
      call patter(ier)
      go to 80
c-- history command
 1400 continue
c     call befor
      go to 80
c-- exec command
 1500 iexec=-1
          endif
      return
c-- modify routine
 1600 continue
      call modify(ier)
      go to 80
 1700 continue
c     kkk=0 
c     call newqua(kkk,ier)
c     go to 80
      ier=-1
      go to 3000
 1800 continue
      call restar(ier)
      go to 80
 1900 continue
      call setperm(ier)
      go to 80
 2000 continue
      ier=-1
      go to 3000
 2100 continue
      ier=-1
      go to 3000
 2200 continue
      ier=-1
      go to 3000
c-- data       routine
 2300 continue
      call procdata(newf,ier)
      go to 80
c-- dummy routine
 2400 continue
      ier=-1
      go to 3000
c-- use routine
 2500 continue
corig call use(newf,ier)
      go to 80
 3000 write(lo,3100) j,allcom(j)
 3100 format(' wrong command code = ',i5,' for ',a14,' command')
      return
 7000 write(lo,7010) ier,fname(3)
 7010 format(' *** error ***  open error, code =',i5,' file is ',a)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine getnum(linei,vet,ivet,iv,iopt)
      dimension vet(40),ivet(40)
      character blank,digit*12,card(100)*80,ffile*80
      character linei*(*),resto*80,cifre*80
      common /chara/ blank,digit,card,ffile
c
      iv=0
      do 1 i=1,40
    1 vet(i)=0.0
      k=len(linei)
      do 2 i=1,80
    2 resto(i:i)=blank
      do 3 i=1,k
    3 resto(i:i)=linei(i:i)
    5 sum=0.0
      isum=0
      call cutst(resto,ncharl,cifre,nchard)
      if (nchard.le.0) return
      segno=1.0
      isegno=1
      iniz=1
      if (cifre(1:1).eq.digit(12:12)) then
                                       segno=-1.0
                                       isegno=-1
                                       iniz=2
                                     endif
      ipoi=index(cifre(1:nchard),digit(11:11))
      if (ipoi.eq.0) ipoi=nchard+1
      dec=ipoi-1-iniz
      idec=ipoi-1-iniz
      do 10 i=iniz,nchard
      idig=index(digit,cifre(i:i))
      if (idig.ge.1.and.idig.le.11)  then
         if (idig.le.10)  then
                            sum=sum+float(idig-1)*10.0**dec
                            if (idec.ge.0) isum=isum*10+(idig-1)
                            dec=dec-1.0
                            idec=idec-1.0
                          endif
                                     else
                                       iopt=-1
                                       return
                                     endif
   10 continue
      iv=iv+1
      vet(iv)=sum*segno
      ivet(iv)=isum*isegno
      if (ncharl.le.0) then
                         iopt=1
                         return
                       endif
      if (iv.eq.iopt) return
      go to 5
      end
c-----------------------------------------------------------------------
      subroutine shift(string,lenp)
      character string*(*)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
c
      k=len(string)
      ifin=1
      do 10 i=1,k
      if (string(i:i).ne.blank) then
                                  iniz=i
                                  go to 20
                                endif
   10 continue
      lenp=-1
      return
   20 do 30 i=k,1,-1
      if (string(i:i).ne.blank) then
                                  ifin=i
                                  go to 40
                                endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
      if (iniz.eq.1) return
      do 50 i=1,lenp
      j=iniz+i-1
   50 string(i:i)=string(j:j)
      if (lenp.eq.k) return
      do 60 i=lenp+1,k
   60 string(i:i)=blank
      return
      end
c-----------------------------------------------------------------------
      subroutine cutst(string,lens,dire,lend)
      character string*(*),dire*(*)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
c
      k=len(dire)
      do 5 i=1,k
    5 dire(i:i)=blank
      k=len(string)
      do 10 i=1,k
      if (string(i:i).eq.blank) then
                                  iniz1=i
                                  go to 20
                                endif
   10 continue
   20 continue
      lend=iniz1-1
      do 25 i=1,lend
      dire(i:i)=string(i:i)
   25 string(i:i)=blank
      call shift(string,lens)
      return
      end
c-----------------------------------------------------------------------
      subroutine summar
c
c-- summarize the content of the direct access file
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/ureq/ ihx(3),none,knw,jpart,jtran,fosog,ifper,iprin,iflag
     *            ,jmpsie,ipripe
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /xdata/ num(350),dmat(3,500),mat(3,8000),mat1(7,1000),
     * lpseud(12),cfom(302),ipos(302),dumx(86534),dummpc(124000)
      integer dmat
c
      call srlin (1,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call yfl01
                      write(lo,30)
                    endif
   30 format(32x,' cell parameters ')
      call srlin (2,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call yfl02
                      write(lo,50) nsym
   50 format(26x,i6,' symmetry operators ')
                    endif
      call srlin (7,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call ysfl07(nrifl,mmm,mmmz,npseud,iy)
                      if (jpart.gt.0) write(lo,160)
                      if (npseud.gt.0) write(lo,140)
                      write(lo,150)nrifl
                    endif
  140 format(32x,' pseudotranslational information')
  150 format(26x,i6,' reflections ')
  160 format(32x,' fragment information')
      call srlin (3,lsn,lixx,ljxx,lkxx,llxx)
      if(lixx.gt.0) then
                      call yfl03
                      write(lo,96) nk
                    endif
   96 format(26x,i6,' atomic species')
      iprea=0
      call srlin (22,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,22,nsem1g,nsem1g,nstron,nxxe,iccd,mat)
      write(lo,244) nsem1g
                   endif
  244 format(26x,i6,' one phase seminvariants ')
      call srlin (23,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,23,nsem2,nsem2,nstron,nxxe,iccd,mat)
      write(lo,254) nsem2
                   endif
  254 format(26x,i6,' two phase seminvariants')
      call srlin (9,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,9,nps,nps,nrefp,nxxe,iccd,mat)
      write(lo,2500) nps
 2500 format(26x,i6,' psi-zero triplets ')
                   endif
      call srlin (24,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,24,ntot,ntrp,nreft,nxxe,iccd,mat)
      write(lo,6010) ntot
                   endif
 6010 format(26x,i6,' psi-e triplets')
      call srlin (8,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,8,ntot,ntrp,nreft,nxxe,iccd,mat)
      write(lo,4010) ntrp
                   endif
 4010 format(26x,i6,' positive triplets')
      call srlin (11,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,11,ntre,ntre,nreft,nxxe,iccd,mat)
      write(lo,4510) ntre
                   endif
 4510 format(26x,i6,' enantiomorph sensitive triplets')
      call srlin (10,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,10,ntrn,ntrn,nreft,nxxe,iccd,mat)
      write(lo,5010) ntrn
                   endif
 5010 format(26x,i6,' negative triplets')
      call srlin (20,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,20,nqn,nqn,nrefp,nxxe,iccd,mat)
      write(lo,5020) nqn
                   endif
 5020 format(26x,i6,' negative quartets ')
      call srlin (21,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,21,nqen,nqen,nrefp,nxxe,iccd,mat)
      write(lo,5030) nqen
                   endif
 5030 format(26x,i6,' enantiomorph sensitive quartets ')
      call srlin (18,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call sflxx(iprea,18,nqq,nqq,nrefp,nxxe,iccd,mat)
      write(lo,5040) nqq
                   endif
 5040 format(26x,i6,' estimated quartets ')
      call srlin (16,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      call ysfl16(cfom,ipos,nset)
      write(lo,5050) nset
                   endif
 5050 format(26x,i6,' sets of phases')
      call srlin (15,lsn,lfw,llw,lpb,ll)
      if(lfw.gt.0) then
      idisp=1
      call sfl15(nats,idisp,numset,interp)
      if (numset.gt.0) then
                         write(lo,5060) nats,numset
                       else
                         write(lo,5070) nats
                       endif
                   endif
 5060 format(26x,i6,' coordinates related to set no.',i4)
 5070 format(26x,i6,' Patterson''s peaks')
      return
      end
c-----------------------------------------------------------------------
code for sortz
      subroutine sortz(lind,numb,iblk,jump)
c--sort the data in store
c
c  lind  addres in store
c  numb  number of block of data to be sorted
c  iblk  block lenght of the data (i.e. number of items per block)
c  jump  < 0 sort in decreasing order
c  jump  > 0 sort in increasing order
c  iabs(jump) = relative addres of the key of sort
c
      common /xdata/ store(244000)
c
      jsig=1
      if (jump.lt.0) then
                       jump=iabs(jump)
                       jsig=-1
                     endif
      if (numb.eq.1) return
      jump=jump-1
      ja=2
2010  continue
      jb=numb/ja
      if(jb) 2020,2020,2030
2020  continue
      jb=1
2030  continue
      jc=numb-jb
2040  continue
      jd=0
      m=lind
      do 2070 i=1,jc
      mk=m+jb*iblk
      if ((store(m+jump)-store(mk+jump))*jsig) 2060,2060,2050
 2050 continue
      mm=m
      mmk=mk
      do 2055 je=1,iblk
      f=store(mm)
      store(mm)=store(mmk)
      store(mmk)=f
      mm=mm+1
      mmk=mmk+1
 2055 continue
      jd=1
 2060 continue
      m=m+iblk
 2070 continue
      if (jd) 2080,2080,2040
 2080 continue
      if (jb-1) 2100,2100,2090
 2090 continue
      ja=ja*2
      go to 2010
 2100 continue
      return
      end
c--------------------------------------------------------
      subroutine ucase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=1,26
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l+26:l+26)
   20 continue
      return
      end
c----------------------------------------------------------------------
      subroutine lcase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
c
      k=len(line)
      do 20 i=1,k
      a=line(i:i)
      l=0
      do 10 j=27,52
      if (a.eq.ulc(j:j)) l=j
   10 continue
      if (l.ne.0) line(i:i)=ulc(l-26:l-26)
   20 continue
      return
      end
c-------------------------------------------------------------
      subroutine wrhead
      character str*80,messh*80
      character fname(9)*80,ext(9)*4
      common/dotdat/ fname,ext
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
c-- write the Header
c
      k=index(fname(1),'.')
      call sirdate(str,icod)
      if (icod.eq.0) then
          messh=' SIRPOW.92 runs on:   '//fname(1)(1:k-1)
        else
          messh=str(1:icod)//' SIRPOW.92 runs on:   '//fname(1)(1:k-1)
        endif
c
      write(lo,10) messh
   10 format(1h ,a,//)
c
      return
      end
